/*  Horloge synchronisée sur réseau Wifi. (France)
 *             Afficheur TM637 
 *
 *  Complétez le programme avec le nom de
 *  votre réseau et son mot de passe.
 *  La luminosité de l'afficheur peut-être ajustée
 *  dans le programme. (De 0 à 7).
 *
 *  Version 6  12/2018.
 *  Version 7  04/2019.
 *  http://f5mna.free.fr
 *
 */

#include <ESP8266WiFi.h>
#include <time.h>
#include <Wire.h>
#include "TM1637.h"
#define CLK 2   // D9
#define DIO 4   // D4

int EteHiver = 12; // Inverseur changement d'heure été/hiver  ((D12 du Wemos D1))

int8_t TimeDisp[] = {0x00, 0x00, 0x00, 0x00};
TM1637 tm1637(CLK, DIO);

int Heure, HeureDiz, HeureUnit, MinutDiz, MinutUnit,JourDiz, i,timezone,E_Hiver;
String Dizheure,Dizheure1, UnitMin, UnitMin1, DizMinute, UnitMinute, Jour;

/////////////////////////////////////////////////
  const char* ssid = "NomdemaBox";              // A Modifier  selon votre box.
  const char* password = "MonmotdePasse";   // A modifier (votre mot de passe).
 

void setup() {
  Serial.begin(9600);
  pinMode (EteHiver, INPUT);  
  tm1637.set();
  tm1637.set(5); //BRIGHT_TYPICAL = 2,BRIGHT_DARKEST = 0,BRIGHTEST = 7; //// Luminosité de l'afficheur
  tm1637.init();

  tm1637.display(0, 8) ;
  tm1637.display(1, 8);
  tm1637.display(2, 8);
  tm1637.display(3, 8);

  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  Serial.println(" Non connecte WiFi");
  while (WiFi.status() != WL_CONNECTED) {
  Serial.print(".");
  delay(1000);
  }
//  configTime(1 * 3600, 0, "pool.ntp.org", "time.nist.gov");
}


String Divisetexte(String data, char separator, int index)
{
  int stringData = 0;
  String dataPart = "";

  for (int i = 0; i < data.length() - 1; i++) { // Un passage pour analyser le texte
    if (data[i] == separator) {// Compte le nombre de caractères de séparation du texte
      stringData++;

    } else if (stringData == index) { //Prend en compte le texte quand le séparateur est présent
      dataPart.concat(data[i]); // Ajout de chaque données entre séparateur


    } else if (stringData > index) {
      return dataPart;
      break;
    }
  }
  return dataPart;
}

void loop() {

 E_Hiver = digitalRead(EteHiver);   // lecture de la touche
 if (E_Hiver == HIGH) timezone = 2; // Ete
 if (E_Hiver == LOW) timezone = 1;  // Hiver  
 configTime(timezone * 3600, 0, "pool.ntp.org", "time.nist.gov");
                                                     
  while (WiFi.status() != WL_CONNECTED) {
    tm1637.display(0, 8) ;
    tm1637.display(1, 8);
    tm1637.point(POINT_ON);
    tm1637.display(2, 8);
    tm1637.display(3, 8);
  }

  time_t now = time(nullptr);
  String Temps = (ctime(&now));
  Serial.println (Temps);

  Jour = ((Divisetexte(Temps, ' ',2)).substring(0,1)); // Dizaine jours
  JourDiz = (Jour.toInt());   //Passage string à int
 //  Serial.print ("DizJour ");  
 // Serial.println (JourDiz);  
  Dizheure  = ((Divisetexte(Temps, ' ',4)).substring(0,1)); // dizaines d'heures
  if (JourDiz > 0 ) (Dizheure = ((Divisetexte(Temps, ' ',3)).substring(0,1))); // dizaines d'heures
  Dizheure1 = ((Divisetexte(Temps, ' ',4)).substring(2,1)); //Heures
  if (JourDiz > 0) (Dizheure1 = ((Divisetexte(Temps, ' ',3)).substring(2,1))); //Heures

  
  UnitMin = ((Divisetexte(Temps, ':', 1)).substring(0,1)); // Dizaines minutes
  UnitMin1 = ((Divisetexte(Temps, ':', 1)).substring(2,1)); // Unité minutes
 /* 
   Serial.print ("Dizheure  ");
   Serial.println(Dizheure);
   Serial.print ("Dizheure1  ");
   Serial.println (Dizheure1);
   Serial.print ("UnitMin   ");
   Serial.println (UnitMin);
   Serial.print ("UnitMin1   ");
   Serial.println (UnitMin1);
   Serial.println();  
 */ 
  
  HeureDiz = (Dizheure.toInt());   //Passage string à int
  HeureUnit = (Dizheure1.toInt());  
  MinutDiz = (UnitMin.toInt());
  MinutUnit  = (UnitMin1.toInt());



  tm1637.point(POINT_ON);
  delay (500);
  TimeDisp[0] =  HeureDiz ;
  TimeDisp[1] =  HeureUnit;
  TimeDisp[2] =  MinutDiz;
  TimeDisp[3] =  MinutUnit;
  tm1637.display(TimeDisp);
  tm1637.point(POINT_OFF);
  delay (500);
  tm1637.display(TimeDisp); 
}


